# MPI_Pack_external_size

## NAME

MPI_Pack_external_size − Calculates upper bound on space needed to write to a portable format

## SYNTAX

## C Syntax

#include <mpi.h>
int MPI_Pack_external_size(char *datarep, int incount,

|  | MPI_Datatype datatype, MPI_Aint *size)

## Fortran Syntax

INCLUDE ’mpif.h’
MPI_PACK_EXTERNAL_SIZE(DATAREP, INCOUNT, DATATYPE, SIZE, IERROR)

| INTEGER |  |  |  | INCOUNT, DATATYPE, IERROR
| INTEGER (KIND=MPI_ADDRESS_KIND) SIZE |  |  |  |
| CHARACTER*(*) |  |  |  | DATAREP

## C++ Syntax

#include <mpi.h>
MPI::Aint MPI::Datatype::Pack_external_size(const char* datarep,

| int incount) const

## INPUT PARAMETERS

| datarep |  | Data representation (string). |
| incount |  | Number of input data items (integer). |
| datatype |  | Datatype of each input data item (handle). |

## OUTPUT PARAMETERS

| size |  | Upper bound on size of packed message, in bytes (integer).
| IERROR |  | Fortran only: Error status (integer).

## DESCRIPTION

MPI_Pack_external_size allows the application to find out how much space is needed to pack a message in the portable format defined by the MPI Forum. It returns in size an upper bound on the increment in position that would occur in a call to MPI_Pack_external with the same values for datarep, incount, and datatype.

The call returns an upper bound, rather than an exact bound, as the exact amount of space needed to pack the message may depend on context and alignment (e.g., the first message packed in a packing unit may take more space).

## NOTES

The datarep argument specifies the data format. The only valid value in the current version of MPI is "external32". The argument is provided for future extensibility.

## ERRORS

Almost all MPI routines return an error value; C routines as the value of the function and Fortran routines in the last argument. C++ functions do not return errors. If the default error handler is set to MPI::ERRORS_THROW_EXCEPTIONS, then on error the C++ exception mechanism will be used to throw an MPI:Exception object.

Before the error value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job, except for I/O function errors. The error handler may be changed with MPI_Comm_set_errhandler; the predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error.

See the MPI man page for a full list of MPI error codes.

## SEE ALSO

MPI_Pack_external
MPI_Unpack_external

MPI API Index